<style>
  .demos {
    text-align: center;
    display: flex;
    flex-flow: row;
    flex-wrap: wrap;
    justify-content: space-between;
    padding: 0;
    width: 90%;
    margin: auto;
  }
  .demos li {
    width: 30%;
    list-style-type:none;
    margin: 20px auto;
    background: #fff;
    box-shadow: 0 3px 6px 0 rgba(0,0,0,0.20);
    border-radius: 2%;
    overflow: hidden;
    transition: .5s ease-in-out;
  }
  .demos li:hover {
    transform: translateY(-8px);
    box-shadow: 0 3px 15px 0 rgba(0,0,0,0.20);
  }
  .demos li span {
    display: inline-block;
    padding: 10px 0;
  }
  .demos li a {
    color: #34495e;
  }

  ul.demos {
    padding-left: 0;
  }
  li.empty {
    visibility: hidden;
  }
</style>

## Basic

<ul class="demos">
  <li>
    <a href="/demo/#">
      <img src="/assets/demo/quick_start.png">
      <span>quick start</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#basic_sprites">
      <img src="/assets/demo/basic_sprites.png">
      <span>basic sprites</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#path_groups">
      <img src="/assets/demo/textures.png">
      <span>path &amp; groups</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#labels">
      <img src="/assets/demo/labels.png">
      <span>labels</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#button">
      <img src="/assets/demo/button.png">
      <span>button</span>
    </index>
  </li>
  <li>
    <a data-nosearch href="/demo/#transforms">
      <img src="/assets/demo/transforms.png">
      <span>transforms</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#events">
      <img src="/assets/demo/events.png">
      <span>events</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#filters">
      <img src="/assets/demo/filters.png">
      <span>filters</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#animations">
      <img src="/assets/demo/animations.png">
      <span>animations</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#svg_path">
      <img src="/assets/demo/svg_path.png">
      <span>svg path</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#offset_api">
      <img src="/assets/demo/offset_api.png">
      <span>offset api</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#groups">
      <img src="/assets/demo/groups.png">
      <span>groups</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#ray">
      <img src="/assets/demo/ray.png">
      <span>ray</span>
    </a>
  </li>
  <!-- <li>
    <a data-nosearch href="/demo/#obb">
      <img src="/assets/demo/obb.png">
      <span>OBB Hit</span>
    </a>
  </li> -->
  <li class="empty"></li>
  <li class="empty"></li>
</ul>

## D3.js

<ul class="demos">
  <li>
    <a data-nosearch href="/demo/#/d3/bar">
      <img src="/assets/demo/d3_bar.png">
      <span>bar graph</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#/d3/hierarchy">
      <img src="/assets/demo/d3_hierarchy.png">
      <span>hierarchy</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#/d3/map">
      <img src="/assets/demo/d3_map.png">
      <span>map</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#/d3/links">
      <img src="/assets/demo/d3_links.png">
      <span>links</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#/d3/map_centroid">
      <img src="/assets/demo/d3_map_centroid.png">
      <span>map centroid</span>
    </index>
  </li>
  <li>
    <a data-nosearch href="/demo/#/d3/map_search">
      <img src="/assets/demo/d3_map_search.png">
      <span>map search</span>
    </a>
  </li>
  <li class="empty"></li>
  <li class="empty"></li>
</ul>

<!-- ## Matter.js

<ul class="demos">
  <li>
    <a data-nosearch href="/demo/#/matterjs/mixed_shapes">
      <img src="/assets/demo/matterjs_mixed_shapes.png">
      <span>mixed shapes</span>
    </a>
  </li>
  <li class="empty"></li>
  <li class="empty"></li>
</ul>

## Proton.js

<ul class="demos">
  <li>
    <a data-nosearch href="/demo/#/proton/behavior">
      <img src="https://p0.ssl.qhimg.com/t010b2c0041913666e0.jpg">
      <span>custom behavior</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#/proton/fire">
      <img src="https://p4.ssl.qhimg.com/t012debb97e0dca4c86.jpg">
      <span>big fire</span>
    </a>
  </li>
  <li>
    <a data-nosearch href="/demo/#/proton/position">
      <img src="https://p3.ssl.qhimg.com/t011e0452ffad2d05ce.jpg">
      <span>bg particles</span>
    </a>
  </li>
  <li class="empty"></li>
  <li class="empty"></li>
</ul> -->
